/* 3sort.c */
/*
 * Autor: Frantiek Dvok <valtri@students.zcu.cz>
 *
 * loha . 3:
 *       V podob procedury Vyber_Max realizujte algoritmus metody vzestupnho azen prvk pole (tabulky) vbrem maximlnho prvku (selection-sort) s vyuitm rekurze. Funkci procedury ovte pomoc jednoduchho programu na vhodn, nepli velk mnoin testovacch dat.
 *
 */

#include <stdlib.h>
#include <stdio.h>

#define MAXN 19


/* generovn nhodnch dat */
void gener_rand(int *pole) {
	int i;

	for (i=0; i<MAXN; i++) pole[i]=rand() % MAXN;
}


/* vpis */
void print_array(int *pole) {
	int i;

	for (i=0; i<MAXN; i++) printf("%4d", pole[i]);
	printf("\n");
}


/* rekurzivn verze Selection-Sort */
void Vyber_Max(int *pole, int range) {
	int i;
	int imax=0;
	int p;

	/* nalezen maximlnho prvku v nesetdn oblasti */
	for (i=0; i<range; i++) {
		if (pole[i]>pole[imax]) imax=i;
	}
	/* jestli u nen maximln prvek na konci, dod se tam */
	if (imax!=range-1) {
		/* prohozen maximlnho a poslednho prvku */
		p=pole[range-1];
		pole[range-1]=pole[imax];
		pole[imax]=p;
	}
	/* rekurziv setdn zbytku pole */
	if (range>1) Vyber_Max(pole, range-1);
}


/* prvn vyvoln rekurzivn procedury Vyber_Max */
void Selection_Sort(int *pole) {
	Vyber_Max(pole, MAXN);
}


int main() {
	int pole[MAXN];

/* generovn nhodnch dat a vpis */
	gener_rand(pole);
	print_array(pole);

/* setdn a vpis */
	Selection_Sort(pole);
	print_array(pole);

	printf("\n");

	return 0;
}
